const { ProvidePlugin } = require('../compiled/webpack');

module.exports = async function addNodePolyfill(opts) {
  const { config } = opts;

  config.plugin('node-polyfill-provider').use(ProvidePlugin, [
    {
      Buffer: ['buffer', 'Buffer'],
    },
  ]);

  // eslint-disable-next-line global-require
  const nodeLibs = require('node-libs-browser');
  config.resolve.fallback.merge({
    ...Object.keys(nodeLibs).reduce((memo, key) => {
      if (nodeLibs[key]) {
        memo[key] = nodeLibs[key];
      } else {
        memo[key] = false;
      }
      return memo;
    }, {}),
    http: false,
    https: false,
  });
};
