const { join } = require('path');
const SpeedMeasurePlugin = require('../compiled/speed-measure-webpack-plugin');
export async function addSpeedMeasureWebpackPlugin(opts) {
  let { webpackConfig } = opts;
  if (process.env.SPEED_MEASURE) {
    const smpOption =
      process.env.SPEED_MEASURE === 'JSON'
        ? {
            outputFormat: 'json',
            outputTarget: join(process.cwd(), 'SPEED_MEASURE.json'),
          }
        : { outputFormat: 'human', outputTarget: console.log };
    webpackConfig = new SpeedMeasurePlugin(smpOption).wrap(webpackConfig);
  }
  return webpackConfig;
}
