import { request } from '@wisdom-utils/utils';
import * as constants from '../../constants';
const API = {
  GET_INFORMATION:
    '/CityInterface/rest/services/CountyProduct.svc/SCADAOper/GetInformationInfo',
  GET_MQTT_SITE_CODE:
    '/CityInterface/rest/services/CountyProduct.svc/SCADAOper/getMqttSitecode',
  GET_ALL_INFORMATION_INFO:
    '/PandaWater/CityWater/Notification/GetAllInformationInfo',
  POST_INFORMATION_STATUS:
    '/PandaWater/CityWater/Notification/PostInformationStatus',
  POST_ADD_OPTIONS:
    '/CityInterface/rest/services/WisdomUnion.svc/CustomerManage/AddOption',
  GET_CURRENT_INFO_TYPE:
    'PandaWater/CityWater/Notification/GetCurrentInfoType',
};

const notificationService = {
  // 获取通知类型列表
  getCurrentInfoType: {
    url: API.GET_CURRENT_INFO_TYPE,
    method: constants.REQUEST_METHOD_GET,
    type: constants.REQUEST_HTTP,
  },
  getInformationInfo: {
    url: API.GET_INFORMATION,
    method: constants.REQUEST_METHOD_GET,
    type: constants.REQUEST_HTTP,
  },
  getMqttSiteCode: {
    url: API.GET_MQTT_SITE_CODE,
    method: constants.REQUEST_METHOD_GET,
    type: constants.REQUEST_HTTP,
  },
  getAllInformationInfo: {
    url: API.GET_ALL_INFORMATION_INFO,
    method: constants.REQUEST_METHOD_GET,
    type: constants.REQUEST_HTTP,
  },
  postInformationStatus: {
    url: API.POST_INFORMATION_STATUS,
    method: constants.REQUEST_METHOD_GET,
    type: constants.REQUEST_HTTP,
  },
  postAddOptions: {
    url: API.POST_ADD_OPTIONS,
    method: constants.REQUEST_METHOD_POST,
    type: constants.REQUEST_HTTP,
  },
};


export default notificationService;
