
// 添加水印方法
export const waterMark = function(settings = {}) {
    //默认设置
    var defaultSettings = {
        watermark_txt: settings.watermark_txt || "",
        watermark_x: 100, //水印起始位置x轴坐标
        watermark_y: 20, //水印起始位置Y轴坐标
        watermark_rows: 20, //水印行数
        watermark_cols: 20, //水印列数
        watermark_x_space: 200, //水印x轴间隔
        watermark_y_space: 150, //水印y轴间隔
        watermark_color: '#aaa', //水印字体颜色
        // watermark_color: 'red', //水印字体颜色
        watermark_alpha: 0.2, //水印透明度
        watermark_fontsize: '16px', //水印字体大小
        watermark_font: '微软雅黑', //水印字体
        watermark_width: 200, //水印宽度
        watermark_height: 160, //水印长度
        watermark_angle: 330 //水印倾斜度数
    };
    //采用配置项替换默认值，作用类似jquery.extend
    if (arguments.length === 1 && typeof arguments[0] === "object") {
        var src = arguments[0] || {};
        for (let key in src) {
            if (src[key] && defaultSettings[key] && src[key] === defaultSettings[key])
                continue;
            else if (src[key])
                defaultSettings[key] = src[key];
        }
    }

    var oTemp = document.createDocumentFragment();

    //获取页面最大宽度
    var page_width = Math.max(document.body.scrollWidth, document.body.clientWidth);
    var cutWidth = page_width * 0.0150;
    var page_width = page_width - cutWidth;
    //获取页面最大高度
    var page_height = Math.max(document.body.scrollHeight, document.body.clientHeight) + 450;
    // var page_height = document.body.scrollHeight+document.body.scrollTop;
    //如果将水印列数设置为0，或水印列数设置过大，超过页面最大宽度，则重新计算水印列数和水印x轴间隔
    if (defaultSettings.watermark_cols == 0 || (parseInt(defaultSettings.watermark_x + defaultSettings.watermark_width * defaultSettings.watermark_cols + defaultSettings.watermark_x_space * (defaultSettings.watermark_cols - 1)) > page_width)) {
        defaultSettings.watermark_cols = parseInt((page_width - defaultSettings.watermark_x + defaultSettings.watermark_x_space) / (defaultSettings.watermark_width + defaultSettings.watermark_x_space));
        defaultSettings.watermark_x_space = parseInt((page_width - defaultSettings.watermark_x - defaultSettings.watermark_width * defaultSettings.watermark_cols) / (defaultSettings.watermark_cols - 1));
    }
    //如果将水印行数设置为0，或水印行数设置过大，超过页面最大长度，则重新计算水印行数和水印y轴间隔
    if (defaultSettings.watermark_rows == 0 || (parseInt(defaultSettings.watermark_y + defaultSettings.watermark_height * defaultSettings.watermark_rows + defaultSettings.watermark_y_space * (defaultSettings.watermark_rows - 1)) > page_height)) {
        defaultSettings.watermark_rows = parseInt((defaultSettings.watermark_y_space + page_height - defaultSettings.watermark_y) / (defaultSettings.watermark_height + defaultSettings.watermark_y_space));
        defaultSettings.watermark_y_space = parseInt(((page_height - defaultSettings.watermark_y) - defaultSettings.watermark_height * defaultSettings.watermark_rows) / (defaultSettings.watermark_rows - 1));
    }
    var x;
    var y;
    for (var i = 0; i < defaultSettings.watermark_rows; i++) {
        y = defaultSettings.watermark_y + (defaultSettings.watermark_y_space + defaultSettings.watermark_height) * i;
        for (var j = 0; j < defaultSettings.watermark_cols; j++) {
            x = defaultSettings.watermark_x + (defaultSettings.watermark_width + defaultSettings.watermark_x_space) * j;

            let watermark_mask_div = document.createElement('div');
            watermark_mask_div.id = 'pandawatermark_mask_div' + i + j;
            watermark_mask_div.className = 'pandawatermark_mask_div';
            watermark_mask_div.appendChild(document.createTextNode(defaultSettings.watermark_txt));
            //设置水印div倾斜显示
            watermark_mask_div.style.webkitTransform = "rotate(-" + defaultSettings.watermark_angle + "deg)";
            watermark_mask_div.style.MozTransform = "rotate(-" + defaultSettings.watermark_angle + "deg)";
            watermark_mask_div.style.msTransform = "rotate(-" + defaultSettings.watermark_angle + "deg)";
            watermark_mask_div.style.OTransform = "rotate(-" + defaultSettings.watermark_angle + "deg)";
            watermark_mask_div.style.transform = "rotate(-" + defaultSettings.watermark_angle + "deg)";
            watermark_mask_div.style.visibility = "";
            watermark_mask_div.style.position = "absolute";
            watermark_mask_div.style.left = x + 'px';
            watermark_mask_div.style.top = y + 'px';
            watermark_mask_div.style.overflow = "hidden";
            watermark_mask_div.style.zIndex = "10000";
            watermark_mask_div.style.pointerEvents = 'none'; //pointer-events:none  让水印不遮挡页面的点击事件
            //watermark_mask_div.style.border="solid #eee 1px";
            watermark_mask_div.style.opacity = defaultSettings.watermark_alpha;
            watermark_mask_div.style.fontSize = defaultSettings.watermark_fontsize;
            watermark_mask_div.style.fontFamily = defaultSettings.watermark_font;
            watermark_mask_div.style.color = defaultSettings.watermark_color;
            watermark_mask_div.style.textAlign = "center";
            watermark_mask_div.style.width = defaultSettings.watermark_width + 'px';
            watermark_mask_div.style.height = defaultSettings.watermark_height + 'px';
            watermark_mask_div.style.display = "flex";
            watermark_mask_div.style.alignItems='center';
            watermark_mask_div.style.justifyContent='center';
            oTemp.appendChild(watermark_mask_div);
            var img = document.createElement('img');
            img.src='/web4/assets/images/logo/单独图案-蓝绿色.svg';
            img.style.marginRight='10px'
            img.style.width='44px'
            img.style.height='24px'
            img.style.marginRight='10px'
            img.style.opacity='0.4'
            watermark_mask_div.prepend(img)
        };
    };
    document.body.appendChild(oTemp);
}